(* :Title: C++ link between QuantLib and Mathematica *)

(* :Context: QuantLib`Common`CppLink` *)

(* :Author: Niels Elken Snderby *)

(* :Mathematica Version: 4.0 *)

(* :Copyright: Copyright (C) 2003 Niels Elken Snderby *)

(* :License:

   This file is part of QuantLib for Mathematica, a Mathematica extension for
   QuantLib, a free-software/open-source financial C++ library
   - http://www.nielses.dk/quantlib/mma
   - http://quantlib.org/

   QuantLib for Mathematica is free software: you can redistribute it and/or 
   modify it under the terms of the QuantLib license.  You should have 
   received a copy of the license along with this program; if not, please 
   email ferdinando@ametrano.net The license is also available online at 
   http://quantlib.org/html/license.html

   This program is distributed in the hope that it will be useful, but 
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
   or FITNESS FOR A PARTICULAR PURPOSE. See the license for more details.
*)

BeginPackage["QuantLib`Common`CppLink`"]

QuantLib::usage = 
"QuantLib gives access to various financial functions from
the QuantLib C++ library. More info: http://www.nielses.dk/quantlib/mma"

If[StringPosition[Uninstall::usage, "QuantLib"] === {},
Uninstall::usage = Uninstall::usage <> " " <>
"Uninstall[QuantLib] can be used to terminate
the external QuantLibMma program.";
]

QuantLibMma::error = "`1`"

Begin["`Private`"]

$link = Install["QuantLib`QuantLibMma`"]

(* $link = Install["C:\\Program Files\\Microsoft Visual Studio\\" <>
                   "MyProjects\\QuantLibMma\\Debug\\QuantLibMma.exe"] *)

Uninstall[QuantLib] ^:= Uninstall[$link];

End[]

EndPackage[]
