/*
 Copyright (C) 2003 Niels Elken Snderby, Mark Treiber

 This file is part of QuantLib for Mathematica, a Mathematica extension for
 QuantLib, a free-software/open-source financial C++ library
 http://www.nielses.dk/quantlib/mma
 http://quantlib.org/

 QuantLib for Mathematica is free software: you can redistribute it and/or
 modify it under the terms of the QuantLib license.  You should have received
 a copy of the license along with this program; if not, please email
 ferdinando@ametrano.net The license is also available online at
 http://quantlib.org/html/license.html

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the license for more details.
*/

#include "qlmma.hpp"

using namespace QuantLib;
using namespace QuantLib::Calendars;
using namespace QuantLib::DayCounters;

RollingConvention getRollingConventionfromnum(int num);

Calendar *createCalendarfromnum(int num);

DayCounter *createDayCounterfromnum(int num);

void qlDayOfWeek(int year, int month, int day);

void qlBusinessDayQ(int year, int month, int day, int calnum);

void qlShiftDate(int year, int month, int day,
                 int shiftYears, int shiftMonths, int shiftDays,
                 int calnum);

void qlRollDate(int year, int month, int day, int calnum, int rollnum);

void qlDaysBetween(int y1, int m1, int d1,
                   int y2, int m2, int d2,
                   int daycountnum);

void qlYearsBetween(int y1, int m1, int d1,
                   int y2, int m2, int d2,
                   int refy1, int refm1, int refd1,
                   int refy2, int refm2, int refd2,
                   int daycountnum);

void qlLeapYearQ(int year);