/*
 Copyright (C) 2003 Niels Elken Snderby

 This file is part of QuantLib for Mathematica, a Mathematica extension for
 QuantLib, a free-software/open-source financial C++ library
 http://www.nielses.dk/quantlib/mma
 http://quantlib.org/

 QuantLib for Mathematica is free software: you can redistribute it and/or
 modify it under the terms of the QuantLib license.  You should have received
 a copy of the license along with this program; if not, please email
 ferdinando@ametrano.net The license is also available online at
 http://quantlib.org/html/license.html

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the license for more details.
*/

#ifndef qlmma_h
#define qlmma_h

#include <ql/quantlib.hpp>

#include "mathlink.h"

using QuantLib::Date;

#define QLML_HANDLE_EXCEPTIONS catch (std::exception& e) { QLMLSignalError(e, true); } catch (...) { QLMLSignalError("unknown error in C++ part of QuantLibMma", true); }

void QLMLSignalError(const char* errorMsg, bool returnFailed = false);

void QLMLSignalError(const std::exception& e, bool returnFailed = false);

void QLMLPutBoolean(MLINK mlp, bool val);

void QLMLPutDate(MLINK mlp, Date date);

void QLMLPutRule(MLINK mlp, const char* symbol, double value);

#endif